import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter_easyrefresh/easy_refresh.dart';
import 'message_item.dart';
import 'package:dio/dio.dart';
import 'package:flutter/semantics.dart';
import 'package:gmalpha_flutter/model/message/message.dart';
import 'package:gmalpha_flutter/netWork/DioUtil.dart';
import 'package:gmalpha_flutter/toast/toast.dart';

class MessageHomePage extends StatefulWidget {
  @override
  _MessageHomePageState createState() => _MessageHomePageState();
}

class _MessageHomePageState extends State<MessageHomePage> with AutomaticKeepAliveClientMixin {

  List<Message> messageList = List<Message>();
  // List<Map> commentsList=[{'name': 'Burial', 'icon': 'http://alpha-s.gmeiapp.com/2018/12/23/921d3a004e-w', 'time': '1.560856220460315E9', 'content':'卖萌打滚求翻牌', 'replied_content': {'content': 'http://alpha.iyanzhi.com/2019/06/18/1833/5f4c9dd92dc7-thumb'}},
  //                         {'name': '거짓말 ', 'icon': 'http://alpha-s.gmeiapp.com/2018/12/23/8179d48c63-w', 'time': '1.560856220460315E9', 'content':'小姐姐，作图app是啥', 'replied_content': {'content': 'http://alpha.iyanzhi.com/2019/06/18/1833/5f4c9dd92dc7-thumb'}},
  //                         {'name': 'blugder ', 'icon': 'http://alpha-s.gmeiapp.com/2018/12/23/8179d48c63-w', 'time': '1.560856220460315E9', 'content':'拍照表情很自然', 'replied_content': {'content': 'http://alpha.iyanzhi.com/2019/06/18/1833/5f4c9dd92dc7-thumb'}},
  //                         ];

  // GlobalKey<EasyRefreshState> _easyRefreshKey =new GlobalKey<EasyRefreshState>();
  // GlobalKey<RefreshFooterState> _footerKey = new GlobalKey<RefreshFooterState>();
  @override
  bool get wantKeepAlive => true;

  Future<List<Message>> _fetchMesssageList() async {
    BaseOptions options = DioUtil.getDefOptions();
    options.baseUrl = "http://earth.gmapp.env/";
    final cookie = new Map<String, dynamic>.from({'_gm_token': 'dfb1d61562677661', '_gtid': 'e49a16069e4411e98014525400e82fab836', 'sessionid': '4w1pyiayin5odywgbosemgul8m28t6x4'});
    HttpConfig config = new HttpConfig(options: options, nativeCookie: cookie);
    DioUtil().setConfig(config);
    print(cookie);
    List<Message> messageList = List<Message>();
    print('aaaaa');
    DioUtil().requestR(Method.get, "api/v1/reply/my",data: {'page': 1, 'count': 10}).then((res){
      print('333333333');
      print(res);
      return messageList;
    }
    ).then((error) {
      print('ddddd');
      print(error);
      // return messageList;
    });
    // print(res);
    return messageList;
    // .then((res){
    //   if (res.code == 0) {
    //     Map<String, dynamic> data = json.decode(res.data);
    //     for (dynamic data in data['data']) {
    //       Message messageData = Message.fromJson(data);
    //       messageList.add(messageData);
    //     }
    //   }
    //   return messageList;
    // }).then((error){
    //   return messageList;
    // });
  
  }

  _getdata() async{
    return _fetchMesssageList();
  }

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
      appBar: new AppBar(
        title: new Text('消息'),
      ),
      floatingActionButton: new FloatingActionButton(
          onPressed: () {
          List<Message> res =  _getdata();

         },
          child: new Icon(Icons.add_box),
          elevation: 3.0,
          highlightElevation: 2.0,
          backgroundColor: Colors.red,        // 红色
        ),
      // body: ListView(children: _getListData()),
      body: new Center(
        // child: FutureBuilder(
        // future: _fetchMesssageList(),
        // builder: (context, snapshot) {
        //   switch (snapshot.connectionState) {
        //     case ConnectionState.none:
        //     case ConnectionState.waiting:
        //       break;
        //     default:
        //      if (snapshot.hasData) {
        //         return _createListView(context, snapshot);
        //       }
        //   }
          
        // },
      ),
      // )
    );
  }
  

  Widget _createListView(BuildContext context, AsyncSnapshot snapshot) {
    List<Message> messageList = snapshot.data;
    return ListView.builder(
      key: new PageStorageKey('message-list'),
      itemCount: messageList.length,
      itemBuilder: (BuildContext context, int index) {
        return new MessageItem(onPressed: (){}, message:messageList[index]);
      },
    );
  }

  }